package cz.mendelu.dnaAnalyser.utils.controller;

import com.fasterxml.jackson.annotation.JsonInclude;
import cz.mendelu.dnaAnalyser.batch.Batch;
import lombok.Data;

import java.util.*;

import static com.fasterxml.jackson.annotation.JsonInclude.Include.NON_NULL;

@Data
@JsonInclude(NON_NULL)
public class ResponsePage<R> {

    public static <E> ResponsePage<E> responsePage(org.springframework.data.domain.Page<E> page) {
        ResponsePage<E> response = new ResponsePage<>();
        response.items = page.getContent();
        response.page.pageSize = page.getSize();
        response.page.pageNumber = page.getNumber();
        response.page.totalPages = page.getTotalPages();
        response.page.totalElements = page.getTotalElements();
        return response;
    }

    private List<R> items;

    private Map<UUID, Batch> batches;

    private Page page = new Page();

    private String downloadToken;

    public ResponsePage() {}


    @Data
    public static class Page {

        public int pageSize;
        public int pageNumber;
        public int totalPages;
        public long totalElements;
        //public Sort sort;
    }
}
