package cz.mendelu.dnaAnalyser.utils.swagger;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;

import java.lang.annotation.*;

/**
 * Created by Jan Kolomazník on 20.6.17.
 */
@Target({ElementType.METHOD, ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Inherited
@Documented
@ApiImplicitParams({
        @ApiImplicitParam(
                name = "pageSize",
                value = "Items in one page, use number or value `ALL`",
                dataType = "string",
                paramType = "query",
                defaultValue = "20",
                example = "10"),
        @ApiImplicitParam(
                name = "pageNumber",
                value = "Page number",
                dataType = "int",
                paramType = "query",
                defaultValue = "0",
                example = "0")/*,
        @ApiImplicitParam(name = "sort", value = "Sorting param, name of properties", dataType = "string", paramType = "query")*/
})
public @interface ApiPaginationParams {
}
